## netplan.io 0.103

=== Makefile ===
NETPLAN_SOVER=0.0

BUILDFLAGS = \
	-g \
	-fPIC \
	-std=c99 \
	-D_XOPEN_SOURCE=500 \
	-DSBINDIR=\"$(SBINDIR)\" \
	-Wall \
	-Werror \
	$(NULL)

SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)
SYSTEMD_UNIT_DIR=$(shell pkg-config --variable=systemdsystemunitdir systemd)
BASH_COMPLETIONS_DIR=$(shell pkg-config --variable=completionsdir bash-completion || echo "/etc/bash_completion.d")

GCOV ?= gcov
ROOTPREFIX ?=
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/lib
ROOTLIBEXECDIR ?= $(ROOTPREFIX)/lib
LIBEXECDIR ?= $(PREFIX)/lib
SBINDIR ?= $(PREFIX)/sbin
DATADIR ?= $(PREFIX)/share
DOCDIR ?= $(DATADIR)/doc
MANDIR ?= $(DATADIR)/man
INCLUDEDIR ?= $(PREFIX)/include

PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py) $(wildcard tests/generator/*.py) $(wildcard tests/dbus/*.py)

# Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
PYFLAKES3 ?= $(shell which pyflakes-3 || which pyflakes3 || echo true)
PYCODESTYLE3 ?= $(shell which pycodestyle-3 || which pycodestyle || which pep8 || echo true)
NOSETESTS3 ?= $(shell which nosetests-3 || which nosetests3 || echo true)

default: netplan/_features.py generate netplan-dbus dbus/io.netplan.Netplan.service doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8 doc/netplan-dbus.8 doc/netplan-get.8 doc/netplan-set.8

%.o: src/%.c
	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -c $^ `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`

libnetplan.so.$(NETPLAN_SOVER): parse.o netplan.o util.o validation.o error.o parse-nm.o
	$(CC) -shared -Wl,-soname,libnetplan.so.$(NETPLAN_SOVER) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ `pkg-config --libs glib-2.0 gio-2.0 yaml-0.1`
	ln -snf libnetplan.so.$(NETPLAN_SOVER) libnetplan.so

generate: libnetplan.so.$(NETPLAN_SOVER) nm.o networkd.o openvswitch.o generate.o sriov.o
	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ -L. -lnetplan `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`

netplan-dbus: src/dbus.c src/_features.h parse.o util.o validation.o error.o
	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(patsubst %.h,,$^) `pkg-config --cflags --libs libsystemd glib-2.0 gio-2.0 yaml-0.1`

src/_features.h: src/[^_]*.[hc]
	printf "#include <stddef.h>\nstatic const char *feature_flags[] __attribute__((__unused__)) = {\n" > $@
	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "\""$$2"\"," }' $^ >> $@
	echo "NULL, };" >> $@

netplan/_features.py: src/[^_]*.[hc]
	echo "# Generated file" > $@
	echo "NETPLAN_FEATURE_FLAGS = [" >> $@
	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "    \""$$2"\"," }' $^ >> $@
	echo "]" >> $@

clean:
	rm -f netplan/_features.py src/_features.h
	rm -f generate doc/*.html doc/*.[1-9]
	rm -f *.o *.so*
	rm -f netplan-dbus dbus/*.service
	rm -f *.gcda *.gcno generate.info
	rm -rf test-coverage .coverage coverage.xml
	find . | grep -E "(__pycache__|\.pyc)" | xargs rm -rf

check: default linting
	tests/cli.py
	LD_LIBRARY_PATH=. $(NOSETESTS3) -v --with-coverage
	tests/validate_docs.sh

linting:
	$(PYFLAKES3) $(PYCODE)
	$(PYCODESTYLE3) --max-line-length=130 $(PYCODE)

coverage: | pre-coverage c-coverage python-coverage

pre-coverage:
	rm -f .coverage
	$(MAKE) CFLAGS="-g -O0 --coverage" clean check
	mkdir -p test-coverage/C test-coverage/python

check-coverage: coverage
	@if grep headerCovTableEntryHi test-coverage/C/index.html | grep -qv '100.*%'; then \
	    echo "FAIL: Test coverage not 100%!" >&2; exit 1; \
	fi
	python3-coverage report --omit=/usr* --show-missing --fail-under=100

c-coverage:
	lcov --directory . --capture --gcov-tool=$(GCOV) -o generate.info
	lcov --remove generate.info "/usr*" -o generate.info
	genhtml -o test-coverage/C/ -t "generate test coverage" generate.info

python-coverage:
	python3-coverage html -d test-coverage/python --omit=/usr* || true
	python3-coverage xml --omit=/usr* || true

install: default
	mkdir -p $(DESTDIR)/$(SBINDIR) $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR) $(DESTDIR)/$(LIBDIR)
	mkdir -p $(DESTDIR)/$(MANDIR)/man5 $(DESTDIR)/$(MANDIR)/man8
	mkdir -p $(DESTDIR)/$(DOCDIR)/netplan/examples
	mkdir -p $(DESTDIR)/$(DATADIR)/netplan/netplan
	mkdir -p $(DESTDIR)/$(INCLUDEDIR)/netplan
	install -m 755 generate $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
	find netplan/ -name '*.py' -exec install -Dm 644 "{}" "$(DESTDIR)/$(DATADIR)/netplan/{}" \;
	install -m 755 src/netplan.script $(DESTDIR)/$(DATADIR)/netplan/
	ln -srf $(DESTDIR)/$(DATADIR)/netplan/netplan.script $(DESTDIR)/$(SBINDIR)/netplan
	ln -srf $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/generate $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)/netplan
	# lib
	install -m 644 *.so.* $(DESTDIR)/$(LIBDIR)/
	ln -snf libnetplan.so.$(NETPLAN_SOVER) $(DESTDIR)/$(LIBDIR)/libnetplan.so
	# headers, dev data
	install -m 644 src/*.h $(DESTDIR)/$(INCLUDEDIR)/netplan/
	# TODO: install pkg-config once available
	# docs, data
	install -m 644 doc/*.html $(DESTDIR)/$(DOCDIR)/netplan/
	install -m 644 examples/*.yaml $(DESTDIR)/$(DOCDIR)/netplan/examples/
	install -m 644 doc/*.5 $(DESTDIR)/$(MANDIR)/man5/
	install -m 644 doc/*.8 $(DESTDIR)/$(MANDIR)/man8/
	install -T -D -m 644 netplan.completions $(DESTDIR)/$(BASH_COMPLETIONS_DIR)/netplan
	# dbus
	mkdir -p $(DESTDIR)/$(DATADIR)/dbus-1/system.d $(DESTDIR)/$(DATADIR)/dbus-1/system-services
	install -m 755 netplan-dbus $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
	install -m 644 dbus/io.netplan.Netplan.conf $(DESTDIR)/$(DATADIR)/dbus-1/system.d/
	install -m 644 dbus/io.netplan.Netplan.service $(DESTDIR)/$(DATADIR)/dbus-1/system-services/

%.service: %.service.in
	sed -e "s#@ROOTLIBEXECDIR@#$(ROOTLIBEXECDIR)#" $< > $@


%.html: %.md
	pandoc -s --toc -o $@ $<

doc/netplan.5: doc/manpage-header.md doc/netplan.md doc/manpage-footer.md
	pandoc -s -o $@ $^

%.8: %.md
	pandoc -s -o $@ $^

.PHONY: clean

=== debian/changelog ===
netplan.io (0.103-0ubuntu7) impish; urgency=medium

  * Add d/p/0006-netplan-set-make-it-possible-to-unset-a-whole-devtyp.patch:
    Fix unset of a devtype subtree, e.g. "netplan set network.ethernets=null".
    (LP: #1942930)

 -- Lukas Märdian <slyon@ubuntu.com>  Tue, 05 Oct 2021 09:41:31 +0200

netplan.io (0.103-0ubuntu6) impish; urgency=medium

  * Add d/p/0005-Implement-YAML-state-tracking-and-use-it-in-the-DBus.patch:
    Allow to pass a state to netplan apply/try so it can cleanup unused
    virtual network interfaces after itself. Make use of this functionality
    inside the DBus Config.Try()/Apply() API and the 'netplan try' CLI.
    (LP: #1943120)

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 27 Sep 2021 16:47:30 +0200

netplan.io (0.103-0ubuntu5) impish; urgency=medium

  * d/patches/nm-1.32.10-compat.patch: ensure the integration tests can manage
    renamed veths (as NetworkManager is better at ignoring these now).

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 01 Sep 2021 16:40:01 +1200

netplan.io (0.103-0ubuntu4) impish; urgency=medium

  * d/p/autopkgtest-fixes.patch: Improve autopkgtest stability.

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 19 Aug 2021 16:30:27 +0200

netplan.io (0.103-0ubuntu3) impish; urgency=medium

  [ Helmut Grohne ]
  * Annotate Build-Depends with <!nocheck>. (Closes: #961466)

  [ Lukas Märdian ]
  * New upstream release: 0.103
    - Add YAML generator and Keyfile parser for NetworkManager YAML backend
    - Add activation-mode parameter, needs systemd v248+ (LP: #1664844)
    - Make use of systemd-networkd's reload/reconfigure commands
    - Deprecate gateway4 & gateway6 in favor of defaults routes (LP: #1756590)
    - Add io.netplan.Netplan.Generate() DBus method
    - Changed the way of how unmanaged-devices are handled by NetworkManager
    - Improve integration test suite (LP: #1922126)
    Bug fixes:
    - Fix ABI regression introduced in 0.102 (LP: #1922898)
    - Fix netplan set if used across partitions (LP: #1930675)
    - Fix handling of multiple gateway4/gateway6 fields (LP: #1901836)
    - Fix parsing of ovs values with colons (LP: #1913906)
    - Fix failure with set-name and bridges
  * Bump systemd dependency to >= v248 for the activation-mode feature
  * Update debian/watch file
  * Drop patches applied upstream
    - Add 0001-parse-nm-fix-32bit-format-string.patch
    - Add d/p/0002-Revert-cli-apply-reload-reconfigure-networkd-instead.patch
      This reverts the systemd-networkd reload/reconfigure usage, due to a
      bug in systemd (< v249) https://github.com/systemd/systemd/issues/18108
  * Update Standards-Version to 4.5.1, no changes required
  * Add Rules-Requires-Root: no to debian/control
  * Add debian/upstream/metadata file

 -- Lukas Märdian <slyon@ubuntu.com>  Fri, 06 Aug 2021 07:56:49 +0200

netplan.io (0.102-0ubuntu6) impish; urgency=medium

  * Add d/p/0004-Improve-integration-tests-interface-ready-waiting-lo.patch
    - Cherry-picked from upstream 9ae9eb7 (LP: #1922126)
  * Add d/p/0005-Fix-NM-unmanaged-devices-changes-behavior-201.patch
    - Cherry-picked from upstream 44dab84
  * Allow running tests in containers, do not break testbed

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 15 Jul 2021 15:34:28 +0200

netplan.io (0.102-0ubuntu4) impish; urgency=medium

  * Refresh regression patch, using gbp
  * Improve flakey wireguard test
  * Skip flaky 'regressions' test on armhf/LXD

 -- Lukas Märdian <slyon@ubuntu.com>  Tue, 04 May 2021 10:06:08 +0200

netplan.io (0.102-0ubuntu3) hirsute; urgency=medium

  * Fix regression (LP: #1922898) for good, by avoiding to break the ABI
    This reverts the "Added ttl option for tunnels" feature
  * Revert previous fix of strict libnetplan dependency

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 19 Apr 2021 13:33:19 +0200

=== debian/control ===
Source: netplan.io
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>,
 Mathieu Trudel-Lapierre <mathieu.tl@gmail.com>,
 Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>
Section: net
Priority: optional
Standards-Version: 4.5.1
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
 bash-completion,
 libyaml-dev,
 libglib2.0-dev,
 uuid-dev,
 python3 (>= 3.1),
 python3-coverage <!nocheck>,
 python3-yaml <!nocheck>,
 python3-netifaces <!nocheck>,
 libsystemd-dev,
 systemd,
 dbus-x11 <!nocheck>,
 pyflakes3 <!nocheck>,
 pycodestyle <!nocheck> | pep8 <!nocheck>,
 python3-nose <!nocheck>,
 pandoc,
 openvswitch-switch <!nocheck>,
Vcs-Git: https://salsa.debian.org/debian/netplan.io.git
Vcs-Browser: https://salsa.debian.org/debian/netplan.io
Homepage: https://netplan.io/

Package: netplan.io
Architecture: linux-any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 iproute2,
 libnetplan0 (>= ${binary:Version}),
 python3,
 python3-yaml,
 python3-netifaces,
 systemd (>= 248~),
Suggests:
 network-manager | wpasupplicant,
 openvswitch-switch,
Conflicts: netplan
Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-1)
Replaces: nplan (<< 0.34~)
Provides: nplan
Description: YAML network configuration abstraction for various backends
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.

Package: libnetplan0
Architecture: linux-any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: YAML network configuration abstraction runtime library
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.
 .
 This package contains the necessary runtime library files.

Package: libnetplan-dev
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends},
 libnetplan0 (= ${binary:Version}),
Description: Development files for netplan's libnetplan runtime library
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.
 .
 This package contains development files for developers wanting to use
 libnetplan in their applications.

=== debian/tests/control ===
Test-Command: python3 tests/integration/run.py --test=ovs
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  openvswitch-switch,
Restrictions: allow-stderr, needs-root, isolation-container, skip-not-installable
Features: test-name=ovs

Test-Command: python3 tests/integration/run.py --test=ethernets
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=ethernets

Test-Command: python3 tests/integration/run.py --test=bridges
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=bridges

Test-Command: python3 tests/integration/run.py --test=bonds
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=bonds

Test-Command: python3 tests/integration/run.py --test=routing
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=routing

Test-Command: python3 tests/integration/run.py --test=vlans
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=vlans

Test-Command: python3 tests/integration/run.py --test=wifi
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container, flaky
Features: test-name=wifi

Test-Command: python3 tests/integration/run.py --test=tunnels
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  wireguard-tools,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=tunnels

Test-Command: python3 tests/integration/run.py --test=scenarios
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container
Features: test-name=scenarios

Test-Command: python3 tests/integration/run.py --test=regressions
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container

## netplan.io 0.104

=== Makefile ===
--- 
+++ 
@@ -6,8 +6,25 @@
 	-std=c99 \
 	-D_XOPEN_SOURCE=500 \
 	-DSBINDIR=\"$(SBINDIR)\" \
+	-I${CURDIR}/include \
 	-Wall \
 	-Werror \
+	$(NULL)
+
+SRCS = \
+	src/abi_compat.c \
+	src/error.c \
+	src/names.c \
+	src/netplan.c \
+	src/networkd.c \
+	src/nm.c \
+	src/openvswitch.c \
+	src/parse.c \
+	src/parse-nm.c \
+	src/sriov.c \
+	src/types.c \
+	src/util.c \
+	src/validation.c \
 	$(NULL)
 
 SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)
@@ -29,24 +46,24 @@
 PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py) $(wildcard tests/generator/*.py) $(wildcard tests/dbus/*.py)
 
 # Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
-PYFLAKES3 ?= $(shell which pyflakes-3 || which pyflakes3 || echo true)
-PYCODESTYLE3 ?= $(shell which pycodestyle-3 || which pycodestyle || which pep8 || echo true)
-NOSETESTS3 ?= $(shell which nosetests-3 || which nosetests3 || echo true)
+PYFLAKES3 ?= $(shell command -v pyflakes-3 || command -v pyflakes3 || echo true)
+PYCODESTYLE3 ?= $(shell command -v pycodestyle-3 || command -v pycodestyle || command -v pep8 || echo true)
+NOSETESTS3 ?= $(shell command -v nosetests-3 || command -v nosetests3 || echo true)
 
 default: netplan/_features.py generate netplan-dbus dbus/io.netplan.Netplan.service doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8 doc/netplan-dbus.8 doc/netplan-get.8 doc/netplan-set.8
 
 %.o: src/%.c
 	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -c $^ `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
 
-libnetplan.so.$(NETPLAN_SOVER): parse.o netplan.o util.o validation.o error.o parse-nm.o
-	$(CC) -shared -Wl,-soname,libnetplan.so.$(NETPLAN_SOVER) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ `pkg-config --libs glib-2.0 gio-2.0 yaml-0.1`
+libnetplan.so.$(NETPLAN_SOVER): $(SRCS) abicompat.lds
+	$(CC) -shared -Wl,-soname,libnetplan.so.$(NETPLAN_SOVER) $(BUILDFLAGS) $(CFLAGS) -fvisibility=hidden $(LDFLAGS) -o $@ $(SRCS) -T abicompat.lds `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
 	ln -snf libnetplan.so.$(NETPLAN_SOVER) libnetplan.so
 
-generate: libnetplan.so.$(NETPLAN_SOVER) nm.o networkd.o openvswitch.o generate.o sriov.o
-	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $^ -L. -lnetplan `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
+generate: libnetplan.so.$(NETPLAN_SOVER) generate.o
+	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter-out $<,$^) -L. -lnetplan `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
 
-netplan-dbus: src/dbus.c src/_features.h parse.o util.o validation.o error.o
-	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(patsubst %.h,,$^) `pkg-config --cflags --libs libsystemd glib-2.0 gio-2.0 yaml-0.1`
+netplan-dbus: libnetplan.so.$(NETPLAN_SOVER) src/_features.h dbus.o
+	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter-out $<,$(patsubst %.h,,$^)) -L. -lnetplan `pkg-config --cflags --libs libsystemd glib-2.0 gio-2.0 yaml-0.1 uuid`
 
 src/_features.h: src/[^_]*.[hc]
 	printf "#include <stddef.h>\nstatic const char *feature_flags[] __attribute__((__unused__)) = {\n" > $@
@@ -114,7 +131,7 @@
 	install -m 644 *.so.* $(DESTDIR)/$(LIBDIR)/
 	ln -snf libnetplan.so.$(NETPLAN_SOVER) $(DESTDIR)/$(LIBDIR)/libnetplan.so
 	# headers, dev data
-	install -m 644 src/*.h $(DESTDIR)/$(INCLUDEDIR)/netplan/
+	install -m 644 include/*.h $(DESTDIR)/$(INCLUDEDIR)/netplan/
 	# TODO: install pkg-config once available
 	# docs, data
 	install -m 644 doc/*.html $(DESTDIR)/$(DOCDIR)/netplan/
@@ -133,7 +150,7 @@
 
 
 %.html: %.md
-	pandoc -s --toc -o $@ $<
+	pandoc -s --metadata title="Netplan reference" --toc -o $@ $<
 
 doc/netplan.5: doc/manpage-header.md doc/netplan.md doc/manpage-footer.md
 	pandoc -s -o $@ $^

=== debian/changelog ===
netplan.io (0.104-0ubuntu2) jammy; urgency=medium

  * Pick upstream commit a4b70e7, to restart networkd if necessary (LP: #1962095)

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 10 Mar 2022 09:45:00 +0100

netplan.io (0.104-0ubuntu1) jammy; urgency=medium

  * New upstream release: 0.104
    - Enable 'embedded-switch-mode' setting on SmartNICs
    - Permit multiple patterns for the driver globs in match (LP: #1918421)
    - Improve routing capabilities (LP: #1892272, LP: #1805038)
    - Support additional link offload options for networkd (LP: #1771740)
    - Handle differing 'ip6-privacy' default value for NetworkManager
    - YAML state tracking for DBus API and 'netplan try' (LP: #1943120)
    - Support ConfigureWithoutCarrier ('ignore-carrier') for networkd
    - Cleanup Makefile, install only public headers
    - Netplan 'get' to use the libnetplan parser
    - libnetplan:
      + introduce the notion of NetplanState
      + use an explicit parser context
      + expose coherent generator APIs
      + improve overall error handling
      + consolidation of YAML parsing into the library
    ATTENTION:
    - Restrict the symbol export to a determined public API
      + We dropped some internal symbols from the API that we know have no
        external consumers, see upstream changelog for list of dropped symbols
    Bug fixes:
    - Fix removal of defunct OVS vlan interfaces (LP: #1959147)
    - Make ConfigManager cleanup on destruction (LP: #1959729)
    - Do not write unvalidated YAML from keyfile (LP: #1952967)
    - Disable tmp address generation for real with NetworkManager (LP: #1948027)
    - Ignore empty YAML hints, delete files on 'set network=null' (LP: #1946957)
    - Wait for 'netplan try' to be ready in DBus API (LP: #1949893)
    - Initialize self.state in 'apply' (LP: #1949104)
    - Driver fallback to nl80211 and/or wext for wpa_supplicant (LP: #1814012)
    - Handle missing 'gateway' in keyfile routes, keep 'dns-search' fallback
    - Make it possible to unset a whole devtype subtree (LP: #1942930)
    - Fix memory leaks, dangling pointers & overall cleanup of API data
  * d/t/control: Add explicit wpasupplicant test Depends
  * d/control: Improved glib (v2.70+-) compat
  * d/control: Strict version dependency on libnetplan
  * d/control: Bump standards version to 4.6.0, improve sections
  * Mute false positive lintian warning
  * d/patches/: Drop patches, applied upstream
  * d/p/autopkgtest-fixes: Refresh
  * d/libnetplan0.symbols: Add new symbols for 0.104
  * d/libnetplan0.symbols: Drop (internal) legacy symbols

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 17 Feb 2022 12:46:23 +0100

netplan.io (0.103-0ubuntu10) jammy; urgency=medium

  * update gbp.conf branch
  * Drop d/p/0002-Revert-cli-apply-reload-reconfigure-networkd-instead.patch
    This is not needed anymore with systemd v249
  * Refresh d/p/0006-netplan-set-make-it-possible-to-unset-a-whole-devtyp.patch
  * Add d/p/0012-test-bridge-base-give-bridge-some-more-time-to-reach.patch
    To fix flaky test_bridge_anonymous autopkgtest (upstream c6ad8e6)
  * Upstream cherry-picks for snapd dbus config set-try-apply integration fixes
    - dbus-wait-for-netplan-try-to-be-ready-LP-1949893-245.patch (LP: #1949893)
    - get-set-ignore-empty-YAML-hints-and-delete-files-on-.patch (LP: #1946957)

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 29 Nov 2021 17:14:32 +0100

netplan.io (0.103-0ubuntu9) jammy; urgency=medium

  [ Lukas Märdian ]
  * Add an upstream patch for glib 2.70 compatibility
  * Add d/p/0010-parse-nm-Handle-missing-gateway-in-keyfile-routes-ke.patch
    (LP: #1949761)
  * Fix regression in 'netplan try' (LP: #1949104)
    + d/p/lp1949104/cli-apply-initialize-self.state-LP-1949104-243.patch
    + d/p/lp1949104/tests-regressions-make-netplan_try-autopkgtest-more-.patch

  [ Andrej Shadura ]
  * Explicitly depend on glib 2.70

 -- Lukas Märdian <slyon@ubuntu.com>  Fri, 05 Nov 2021 09:14:58 +0100

netplan.io (0.103-0ubuntu8) jammy; urgency=medium

  * d/p/0001-Add-support-for-additional-Link-options-225-LP-17717.patch:
    - Add offload configuration options.
      (LP: #1771740)
  * Add d/p/partial-d4884cfd40e1e33540b274371c3272df6595d22c.patch:
    - Partial application of d4884cfd40e1e33540b274371c3272df6595d22c in order
      preserve ABI compatibility for future updates.

 -- Nicolas Bock <nicolas.bock@canonical.com>  Sat, 09 Oct 2021 16:27:57 -0600

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>
 Section: net
 Priority: optional
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -39,7 +39,7 @@
  ${shlibs:Depends},
  ${misc:Depends},
  iproute2,
- libnetplan0 (>= ${binary:Version}),
+ libnetplan0 (= ${binary:Version}),
  python3,
  python3-yaml,
  python3-netifaces,
@@ -61,6 +61,7 @@
  Currently supported backends are networkd and NetworkManager.
 
 Package: libnetplan0
+Section: libs
 Architecture: linux-any
 Multi-Arch: same
 Depends:
@@ -78,6 +79,7 @@
  This package contains the necessary runtime library files.
 
 Package: libnetplan-dev
+Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
 Depends: ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH}

.PHOHY: override_dh_auto_install

=== debian/tests/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -18,6 +19,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -31,6 +33,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -44,6 +47,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -57,6 +61,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -70,6 +75,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -83,6 +89,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -96,6 +103,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -110,6 +118,7 @@
   systemd,
   network-manager,
   hostapd,
+  wpasupplicant,
   dnsmasq-base,
   libnm0,
   python3-gi,
@@ -121,10 +130,3 @@
 Tests-Directory: tests/integration
 Depends: @,
   systemd,
-  network-manager,
-  hostapd,
-  dnsmasq-base,
-  libnm0,
-  python3-gi,
-  gir1.2-nm-1.0,
-Restrictions: allow-stderr, needs-root, isolation-container

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com/canonical/netplan/tags .*/v?(\d\S+)\.tar\.gz

## netplan.io 0.105

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	-g \
 	-fPIC \
 	-std=c99 \
-	-D_XOPEN_SOURCE=500 \
+	-D_XOPEN_SOURCE=700 \
 	-DSBINDIR=\"$(SBINDIR)\" \
 	-I${CURDIR}/include \
 	-Wall \
@@ -52,7 +52,7 @@
 
 default: netplan/_features.py generate netplan-dbus dbus/io.netplan.Netplan.service doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8 doc/netplan-dbus.8 doc/netplan-get.8 doc/netplan-set.8
 
-%.o: src/%.c
+%.o: src/%.c src/_features.h
 	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -c $^ `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
 
 libnetplan.so.$(NETPLAN_SOVER): $(SRCS) abicompat.lds
@@ -62,7 +62,7 @@
 generate: libnetplan.so.$(NETPLAN_SOVER) generate.o
 	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter-out $<,$^) -L. -lnetplan `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
 
-netplan-dbus: libnetplan.so.$(NETPLAN_SOVER) src/_features.h dbus.o
+netplan-dbus: libnetplan.so.$(NETPLAN_SOVER) dbus.o
 	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter-out $<,$(patsubst %.h,,$^)) -L. -lnetplan `pkg-config --cflags --libs libsystemd glib-2.0 gio-2.0 yaml-0.1 uuid`
 
 src/_features.h: src/[^_]*.[hc]
@@ -77,7 +77,7 @@
 	echo "]" >> $@
 
 clean:
-	rm -f netplan/_features.py src/_features.h
+	rm -f netplan/_features.py src/_features.h src/_features.h.gch
 	rm -f generate doc/*.html doc/*.[1-9]
 	rm -f *.o *.so*
 	rm -f netplan-dbus dbus/*.service
@@ -86,8 +86,8 @@
 	find . | grep -E "(__pycache__|\.pyc)" | xargs rm -rf
 
 check: default linting
-	tests/cli.py
-	LD_LIBRARY_PATH=. $(NOSETESTS3) -v --with-coverage
+	PYTHONPATH=. LD_LIBRARY_PATH=. tests/cli.py
+	PYTHONPATH=. LD_LIBRARY_PATH=. $(NOSETESTS3) -v --with-coverage
 	tests/validate_docs.sh
 
 linting:
@@ -152,10 +152,10 @@
 %.html: %.md
 	pandoc -s --metadata title="Netplan reference" --toc -o $@ $<
 
-doc/netplan.5: doc/manpage-header.md doc/netplan.md doc/manpage-footer.md
-	pandoc -s -o $@ $^
+doc/netplan.5: doc/manpage-header.md doc/netplan-yaml.md doc/manpage-footer.md
+	pandoc -s -o $@ --from=markdown-smart $^
 
 %.8: %.md
-	pandoc -s -o $@ $^
+	pandoc -s -o $@ --from=markdown-smart $^
 
 .PHONY: clean

=== debian/changelog ===
netplan.io (0.105-3) unstable; urgency=medium

  * d/patches: Migrate from deprecated nose to pytest (Closes: #1020079)
  * d/control: drop python3-nose B-D in favor of pytest (Closes: #1018420)

 -- Lukas Märdian <luk@slyon.de>  Mon, 02 Jan 2023 11:46:01 +0100

netplan.io (0.105-2) unstable; urgency=medium

  * d/copyright: Update metadata.
  * d/netplan.io.lintian-overrides: Fix new style override.
  * d/t/control: Make it work with old and new systemd[-resolved].
  * d/p/0002-buildsystem-meson-fixes.patch: improve meson build.
  * d/rules,d/control,d/libnetplan.io.install,d/libnetplan-dev.install:
    + Use meson build system and enable hardening flags
    + Ship netplan.pc file and move netplan's systemd generator to LIBEXECDIR

 -- Lukas Märdian <luk@slyon.de>  Wed, 24 Aug 2022 12:59:21 +0200

netplan.io (0.105-1) unstable; urgency=medium

  * Merge new upstream release 0.105 (from tag ubuntu/0.105-0ubuntu1)
    - Add support for VXLAN tunnels (#288), LP: #1764716
    - Add support for VRF devices (#285), LP: #1773522
    - Add support for InfiniBand (IPoIB) (#283), LP: #1848471
    - Allow key configuration for GRE tunnels (#274), LP: #1966476
    - Allow setting the regulatory domain (#281), LP: #1951586
    - Documentation improvements & restructuring (#287)
    - Add meson build system (#268)
    - Add abigail ABI compatibility checker (#269)
    - Update of Fedora RPM spec (#264)
    - CI improvements (#265, #282)
    - Netplan `set` uses the consolidated libnetplan YAML parser (#254)
    - Refactor ConfigManager to use the libnetplan YAML parser (#255)
    - New `netplan_netdef_get_filepath` API (#275)
    - Improve NetworkManager device management logic (#276), LP: #1951653
    Bug fixes:
    - Fix `apply` netdev rename/create race condition (#260), LP: #1962095
    - Fix `try` timeout (#271), LP: #1967084
    - Fix infinite timeouts in ovs-vsctl (#266), Closes: #1000137
    - Fix offload options using tristate setting (#270), LP: #1956264
    - Fix rendering of NetworkManager passthrough WPA (#279), LP: #1972800
    - Fix CLI crash on LibNetplanException (#286)
    - Fix NetworkManager internal DHCP client lease lookup (#284), LP: #1979674
  * Update symbols file for 0.105
  * d/patches/: Drop patches, applied upstream
  * d/patches/autopkgtest-fixes.patch: Refresh
  * d/p/autopkgtest-fixes.patch: Drop test quirks (PR#276)
  * d/control, d/tests/control: suggest/add iw for setting a regulatory domain

 -- Lukas Märdian <luk@slyon.de>  Thu, 18 Aug 2022 15:35:31 +0200

netplan.io (0.104-2) unstable; urgency=medium

  [ Lukas Märdian ]
  * d/control: Update Standards-Version, no changes needed.

  [ Andrej Shadura ]
  * Make autopkgtests depend on systemd-resolved (Closes: #1017347).

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 14 Aug 2022 14:58:56 +0200

netplan.io (0.104-1) unstable; urgency=medium

  * Merge new upstream release 0.104 (from tag ubuntu/0.104-0ubuntu4)
    - Enable 'embedded-switch-mode' setting on SmartNICs
    - Permit multiple patterns for the driver globs in match (LP: #1918421)
    - Improve routing capabilities (LP: #1892272, LP: #1805038)
    - Support additional link offload options for networkd (LP: #1771740)
      + Backport offloading tristate patches (LP: #1956264)
        d/p/0003-Add-tristate-type-for-offload-options-LP-1956264-270.patch
    - Handle differing 'ip6-privacy' default value for NetworkManager
    - YAML state tracking for DBus API and 'netplan try' (LP: #1943120)
    - Support ConfigureWithoutCarrier ('ignore-carrier') for networkd
    - Cleanup Makefile, install only public headers
    - Netplan 'get' to use the libnetplan parser
    - libnetplan:
      + introduce the notion of NetplanState
      + use an explicit parser context
      + expose coherent generator APIs
      + improve overall error handling
      + consolidation of YAML parsing into the library
    ATTENTION:
    - Restrict the symbol export to a determined public API
      + We dropped some internal symbols from the API that we know have no
        external consumers, see upstream changelog for list of dropped symbols
    Bug fixes:
    - Fix removal of defunct OVS vlan interfaces (LP: #1959147)
    - Make ConfigManager cleanup on destruction (LP: #1959729)
    - Do not write unvalidated YAML from keyfile (LP: #1952967)
    - Disable tmp address generation for real with NetworkManager, LP: #1948027
    - Ignore empty YAML hints, delete files on 'set network=null', LP: #1946957
    - Wait for 'netplan try' to be ready in DBus API (LP: #1949893)
    - Initialize self.state in 'apply' (LP: #1949104)
    - Driver fallback to nl80211 and/or wext for wpa_supplicant (LP: #1814012)
    - Handle missing 'gateway' in keyfile routes, keep 'dns-search' fallback
    - Make it possible to unset a whole devtype subtree (LP: #1942930)
    - Fix memory leaks, dangling pointers & overall cleanup of API data
    - Upstream fix a4b70e7, to restart networkd if necessary (LP: #1962095)
    - Cherry-pick upstream fix (565bd0f) for ethernets autopkgtest:
      - d/p/0004-tests-ethernets-fix-autopkgtest-with-alternating-def.patch
    - Cherry-pick upstream fix (8934a1b) for NM WPA3 passthrough:
      - d/p/0005-nm-fix-rendering-of-password-for-unknown-passthrough.patch
  * d/control: Improved glib (v2.70+-) compat
  * d/control: Strict version dependency on libnetplan
  * d/control: Remove unnecessary constraints
  * Mute false positive lintian warning
  * d/libnetplan0.symbols: Add new symbols for 0.104
  * d/libnetplan0.symbols: Drop (internal) legacy symbols
  * d/t/control: add 'ethtool' test-dep for link offloading tests
  * Remaining changes:
    - refreshed d/p/ovs-timeout.patch
    - refreshed d/p/autopkgtest-fixes.patch
  * Dropped changes, applied upstream
    - d/p/0001-parse-nm-fix-32bit-format-string.patch
    - d/p/glib-2.70-compat.patch
    - d/p/nm-1.32.10-compat.patch

 -- Lukas Märdian <luk@slyon.de>  Tue, 14 Jun 2022 17:39:24 +0200



=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: netplan.io
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
+Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>,
  Mathieu Trudel-Lapierre <mathieu.tl@gmail.com>,
- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>
+ Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>,
+ Lukas Märdian <luk@slyon.de>
 Section: net
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -16,8 +16,10 @@
  libyaml-dev,
  libglib2.0-dev,
  uuid-dev,
- python3 (>= 3.1),
+ python3,
  python3-coverage <!nocheck>,
+ python3-pytest <!nocheck>,
+ python3-pytest-cov <!nocheck>,
  python3-yaml <!nocheck>,
  python3-netifaces <!nocheck>,
  libsystemd-dev,
@@ -25,9 +27,9 @@
  dbus-x11 <!nocheck>,
  pyflakes3 <!nocheck>,
  pycodestyle <!nocheck> | pep8 <!nocheck>,
- python3-nose <!nocheck>,
  pandoc,
  openvswitch-switch <!nocheck>,
+ meson,
 Vcs-Git: https://salsa.debian.org/debian/netplan.io.git
 Vcs-Browser: https://salsa.debian.org/debian/netplan.io
 Homepage: https://netplan.io/
@@ -47,8 +49,9 @@
 Suggests:
  network-manager | wpasupplicant,
  openvswitch-switch,
+ iw,
 Conflicts: netplan
-Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-1)
+Breaks: nplan (<< 0.34~)
 Replaces: nplan (<< 0.34~)
 Provides: nplan
 Description: YAML network configuration abstraction for various backends

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson

=== debian/tests/control ===
Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=ovs
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  openvswitch-switch,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed, skip-not-installable, flaky
Features: test-name=ovs

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=ethernets
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  ethtool,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed, flaky
Features: test-name=ethernets

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=bridges
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed, flaky
Features: test-name=bridges

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=bonds
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed, flaky
Features: test-name=bonds

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=routing
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed
Features: test-name=routing

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=vlans
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed, flaky
Features: test-name=vlans

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=wifi
Tests-Directory: tests/integration
Depends: @,
  systemd-resolved | systemd (<< 251.3-2~),
  network-manager,
  hostapd,
  wpasupplicant,
  dnsmasq-base,
  libnm0,
  python3-gi,
  gir1.2-nm-1.0,
  iw,
Restrictions: allow-stderr, needs-root, isolation-container, breaks-testbed, flaky
Features: test-name=wifi

Test-Command: ./debian/tests/prepare-testbed.sh && python3 tests/integration/run.py --test=tunnels

## netplan.io 0.106

=== Makefile ===
--- 
+++ 
@@ -4,11 +4,20 @@
 	-g \
 	-fPIC \
 	-std=c99 \
-	-D_XOPEN_SOURCE=700 \
+	-D_GNU_SOURCE \
 	-DSBINDIR=\"$(SBINDIR)\" \
 	-I${CURDIR}/include \
 	-Wall \
 	-Werror \
+	$(NULL)
+
+TESTFLAGS =	\
+	-g \
+	-O0 \
+	-DFIXTURESDIR=\"$(shell pwd)/tests/ctests/fixtures\" \
+	-Isrc \
+	--coverage \
+	-lcmocka \
 	$(NULL)
 
 SRCS = \
@@ -27,6 +36,13 @@
 	src/validation.c \
 	$(NULL)
 
+TESTS = \
+	tests/ctests/test_netplan_error \
+	tests/ctests/test_netplan_misc \
+	tests/ctests/test_netplan_parser \
+	tests/ctests/test_netplan_state \
+	$(NULL)
+
 SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)
 SYSTEMD_UNIT_DIR=$(shell pkg-config --variable=systemdsystemunitdir systemd)
 BASH_COMPLETIONS_DIR=$(shell pkg-config --variable=completionsdir bash-completion || echo "/etc/bash_completion.d")
@@ -43,12 +59,13 @@
 MANDIR ?= $(DATADIR)/man
 INCLUDEDIR ?= $(PREFIX)/include
 
-PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py) $(wildcard tests/generator/*.py) $(wildcard tests/dbus/*.py)
+PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py) $(wildcard tests/generator/*.py) $(wildcard tests/cli/*.py) $(wildcard tests/netplan_dbus/*.py) $(wildcard tests/integration/*.py) $(wildcard tests/parser/*.py)
 
 # Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
 PYFLAKES3 ?= $(shell command -v pyflakes-3 || command -v pyflakes3 || echo true)
 PYCODESTYLE3 ?= $(shell command -v pycodestyle-3 || command -v pycodestyle || command -v pep8 || echo true)
-NOSETESTS3 ?= $(shell command -v nosetests-3 || command -v nosetests3 || echo true)
+PYTEST3 ?= $(shell command -v pytest-3 || command -v pytest3 || echo true)
+PYCOVERAGE ?= $(shell command -v python3-coverage || echo true)
 
 default: netplan/_features.py generate netplan-dbus dbus/io.netplan.Netplan.service doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8 doc/netplan-dbus.8 doc/netplan-get.8 doc/netplan-set.8
 
@@ -76,25 +93,31 @@
 	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "    \""$$2"\"," }' $^ >> $@
 	echo "]" >> $@
 
+$(TESTS): %: %.c
+	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $< `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid` $(TESTFLAGS)
+	./$@
+
 clean:
 	rm -f netplan/_features.py src/_features.h src/_features.h.gch
 	rm -f generate doc/*.html doc/*.[1-9]
 	rm -f *.o *.so*
 	rm -f netplan-dbus dbus/*.service
 	rm -f *.gcda *.gcno generate.info
+	rm -f tests/ctests/*.gcda tests/ctests/*.gcno
 	rm -rf test-coverage .coverage coverage.xml
 	find . | grep -E "(__pycache__|\.pyc)" | xargs rm -rf
+	rm -f $(TESTS)
 
-check: default linting
-	PYTHONPATH=. LD_LIBRARY_PATH=. tests/cli.py
-	PYTHONPATH=. LD_LIBRARY_PATH=. $(NOSETESTS3) -v --with-coverage
+check: default linting $(TESTS)
+	PYTHONPATH=. LD_LIBRARY_PATH=. tests/cli_legacy.py
+	PYTHONPATH=. LD_LIBRARY_PATH=. $(PYCOVERAGE) run -a -m pytest -s -v --cov-append
 	tests/validate_docs.sh
 
 linting:
 	$(PYFLAKES3) $(PYCODE)
 	$(PYCODESTYLE3) --max-line-length=130 $(PYCODE)
 
-coverage: | pre-coverage c-coverage python-coverage
+coverage: | pre-coverage c-coverage python-coverage-combine python-coverage
 
 pre-coverage:
 	rm -f .coverage
@@ -111,6 +134,9 @@
 	lcov --directory . --capture --gcov-tool=$(GCOV) -o generate.info
 	lcov --remove generate.info "/usr*" -o generate.info
 	genhtml -o test-coverage/C/ -t "generate test coverage" generate.info
+
+python-coverage-combine:
+	python3-coverage combine -a
 
 python-coverage:
 	python3-coverage html -d test-coverage/python --omit=/usr* || true
@@ -152,10 +178,10 @@
 %.html: %.md
 	pandoc -s --metadata title="Netplan reference" --toc -o $@ $<
 
-doc/netplan.5: doc/manpage-header.md doc/netplan-yaml.md doc/manpage-footer.md
+doc/netplan.5: doc/manpage-header.md doc/structure-id.md doc/netplan-yaml.md doc/manpage-footer.md
 	pandoc -s -o $@ --from=markdown-smart $^
 
 %.8: %.md
-	pandoc -s -o $@ --from=markdown-smart $^
+	pandoc -s -o $@ --shift-heading-level-by=-1 --from=markdown-smart $^
 
 .PHONY: clean

=== meson_options.txt ===
option('unit_testing', type: 'boolean', value: true)

=== doc/requirements.txt ===
sphinx
furo
sphinx-design
sphinxcontrib-spelling
sphinx-autobuild
pyenchant
myst-parser

=== debian/changelog ===
netplan.io (0.106-2+deb12u1) bookworm; urgency=medium

  * debian/tests: Fix testbed timeout with systemd v252.15 (Closes: #1053496)

 -- Lukas Märdian <slyon@debian.org>  Tue, 24 Oct 2023 12:48:28 +0200

netplan.io (0.106-2) unstable; urgency=medium

  * Fix DBus .Config/.Get APIs using upstream commits (PR#331) (LP: #1997467)
  * Enable additional 'dbus' autopkgtests to check the regressed cases

 -- Lukas Märdian <luk@slyon.de>  Thu, 02 Mar 2023 17:40:56 +0100

netplan.io (0.106-1) unstable; urgency=medium

  * Merge new upstream release 0.106 (from 0.106-0ubuntu1)
    - New 'netplan status' CLI (#290)
    - API: implement APIs from the new specification (#298)
    - Check and fix non-inclusive laguange (#303)
    - Documentation improvements (using Diátaxis & RTD)
    - Match by PermanentMACAddress (#278)
    - Netplan api iterator (#306)
    - API: update netplan_delete_connection() (#322)
    - NM 1.40 compat & file permission fixes (#300), LP: #1862600, LP: #1997348
    - Migrate from (deprecated) nose to pytest (#302)
    - parse: Add the filepath to OVS ports netdefs (#295)
    - Check if the interface name is too long (#313), LP: #1988749
    - doc/examples: remove unnecessary route for IPv6 on-link gateways (#312)
    - Memory leak CI action (#321)
    - tests:base:ethernets: Improve stability of autopkgtests (#223)
    Bug fixes:
    - Fix some memory leaks (#297)
    - parser: plug a memory leak (#309)
    - src:parse: plug memory leaks in nullable handling (#319)
    - Fix 'netplan ip leases' crash (#301), LP: #1996941
    - tests: mock calls to systemctl (#314)
    - ctests: fix an integer conversion issue (#315)
    - docs: small fix on netplan-set doc (#316)
    - parser: return the correct error on failure (#308), LP: #2000324
    - apply: Fix crash when OVS is stopped (#307),LP: #1995598
    - networkd: make sure VXLAN is in the right section (#310), LP: #2000713
    - cli:set: update only specific origin-hint if given (#299), LP: #1997467
    - vxlan: convert some settings to tristate (#311), LP: #2000712
    - parser: check for route duplicates (#320), LP: #2003061
  * Update symbols file for 0.106
  * d/patches/: Drop patches, applied upstream
  * d/control: bump Standards-Version to 4.6.2, no changes needed
  * d/t/control: prepare Debian testbed
  * d/control: Add python3-dbus, python3-rich deps, also CMocka and Pytest B-Ds
  * d/watch: fix checking for upstream tags
  * d/copyright: Update for 2023
  * d/source/: add lintian-overrides
  * d/gbp.conf: use pristine-tar

 -- Lukas Märdian <luk@slyon.de>  Thu, 09 Feb 2023 12:09:04 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Lukas Märdian <luk@slyon.de>
 Section: net
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -18,10 +18,13 @@
  uuid-dev,
  python3,
  python3-coverage <!nocheck>,
+ python3-dbus <!nocheck>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <!nocheck>,
+ python3-rich <!nocheck>,
  python3-yaml <!nocheck>,
  python3-netifaces <!nocheck>,
+ libcmocka-dev,
  libsystemd-dev,
  systemd,
  dbus-x11 <!nocheck>,
@@ -43,6 +46,8 @@
  iproute2,
  libnetplan0 (= ${binary:Version}),
  python3,
+ python3-dbus,
+ python3-rich,
  python3-yaml,
  python3-netifaces,
  systemd (>= 248~),

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?@ANY_VERSION@@ARCHIVE_EXT@/@PACKAGE@-$1.tar.gz/,uversionmangle=s/-?rc/~rc/  \
  https://github.com/canonical/netplan/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
